from dataclasses import dataclass, field

from proto_proto_pscr.cb_psc_event_pb2 import CbAlertOperator, CbAlertClassification

from sensor_comms.protobuf_requests.event_messages import MessageDataClass
from sensor_comms.protobuf_requests.event_messages.alert.alert_operator import AlertOperator


@dataclass
class AlertClassification(MessageDataClass):
    """
    Dataclass that maps to the CbAlertClassification protobuf message
    """

    alert_classification: int = field(default=CbAlertClassification.CbAlertClassificationType.Value('TRUE_POSITIVE'))
    changed_by: CbAlertOperator = field(default=None, metadata={'dataclass_type': AlertOperator})
    last_update_timestamp: str = field(default=None)
    alert_sub_classification: int = field(
        default=CbAlertClassification.CbAlertSubClassificationType.Value('NOT_APPLICABLE')
    )
    alert_determination_code: int = field(
        default=CbAlertClassification.CbAlertDeterminationCodeType.Value('ALERT_DETERMINATION_CODE_UNKNOWN')
    )
    _message_type: str = field(init=False, repr=False, default='CbAlertClassification')
