from dataclasses import dataclass, field

from typing import List

from proto_proto_pscr.cb_psc_event_pb2 import CbModelManifest, MlFeatures, CbPredictionScore

from sensor_comms.protobuf_requests.event_messages import MessageDataClass
from sensor_comms.protobuf_requests.event_messages.alert.model_manifest import ModelManifest
from sensor_comms.protobuf_requests.event_messages.alert.ml_features import MlFeaturesDC
from sensor_comms.protobuf_requests.event_messages.alert.prediction_score import PredictionScore


@dataclass
class AlertClassificationPrediction(MessageDataClass):
    """
    Dataclass that maps to the CbAlertClassificationPrediction protobuf message
    """

    model_manifest: CbModelManifest = field(default=None, metadata={'dataclass_type': ModelManifest})
    ml_features: List[MlFeatures] = field(default_factory=list, metadata={'dataclass_type': MlFeaturesDC})
    prediction_score: CbPredictionScore = field(default=None, metadata={'dataclass_type': PredictionScore})
    model_enabled: bool = field(default=False)
    _message_type: str = field(init=False, repr=False, default='CbAlertClassificationPrediction')
