from dataclasses import dataclass, field

from typing import List

from proto_proto_pscr.cb_psc_event_pb2 import (
    CbAlertClassificationPrediction,
    CbAlertClassificationPredictionList,
    CbKeyValue,
)

from sensor_comms.protobuf_requests.event_messages import MessageDataClass
from sensor_comms.protobuf_requests.event_messages.alert.alert_classification_prediction import (
    AlertClassificationPrediction,
)
from sensor_comms.protobuf_requests.event_messages.key_value import KeyValue


@dataclass
class AlertClassificationPredictionList(MessageDataClass):
    """
    Dataclass that maps to the CbAlertClassificationPredictionList protobuf message
    """

    alert_classification_prediction: List[CbAlertClassificationPrediction] = field(
        default_factory=list, metadata={'dataclass_type': AlertClassificationPrediction}
    )
    final_verdict: int = field(default=CbAlertClassificationPredictionList.Prediction.Value('NO_PREDICTION'))
    global_prevalence: int = field(default=CbAlertClassificationPredictionList.SeverityScale.Value('UNKNOWN'))
    org_prevalence: int = field(default=CbAlertClassificationPredictionList.SeverityScale.Value('UNKNOWN'))
    device_risk: int = field(default=CbAlertClassificationPredictionList.SeverityScale.Value('UNKNOWN'))
    cmdline_cluster_id: str = field(default=None)
    cmdline_cluster_label: str = field(default=None)
    cmdline_tlsh: str = field(default=None)
    debug_info: List[CbKeyValue] = field(default_factory=list, metadata={'dataclass_type': KeyValue})
    reason: List[CbKeyValue] = field(default_factory=list, metadata={'dataclass_type': KeyValue})
    _message_type: str = field(init=False, repr=False, default='CbAlertClassificationPredictionList')
