from dataclasses import dataclass, field

from typing import List

from proto_proto_pscr.cb_psc_event_pb2 import CbAlertStateDetails, CbAlertNote, CbAlertUpdateDetails

from sensor_comms.protobuf_requests.event_messages import MessageDataClass
from sensor_comms.protobuf_requests.event_messages.alert.alert_state_details import AlertStateDetails
from sensor_comms.protobuf_requests.event_messages.alert.alert_note import AlertNote


@dataclass
class AlertUpdateDetails(MessageDataClass):
    """
    Dataclass that maps to the CbAlertUpdateDetails protobuf message
    """

    old_user_state_details: CbAlertStateDetails = field(default=None, metadata={'dataclass_type': AlertStateDetails})
    old_mdr_state_details: CbAlertStateDetails = field(default=None, metadata={'dataclass_type': AlertStateDetails})
    old_alert_note: CbAlertNote = field(default=None, metadata={'dataclass_type': AlertNote})
    update_type: int = field(default=CbAlertUpdateDetails.AlertUpdateType.Value('NO_CHANGE'))
    old_threat_score: int = field(default=None)
    update_types: List[int] = field(default_factory=list)
    _message_type: str = field(init=False, repr=False, default='CbAlertUpdateDetails')
