from dataclasses import dataclass, field

from proto_proto_pscr.cb_psc_event_pb2 import CbAlertOperator, CbAlertSuppressionNote

from sensor_comms.protobuf_requests.event_messages import MessageDataClass
from sensor_comms.protobuf_requests.event_messages.alert.alert_operator import AlertOperator
from sensor_comms.protobuf_requests.event_messages.alert.alert_suppression_note import AlertSuppressionNote


@dataclass
class AlertWorkflowState(MessageDataClass):
    # pylint: disable=too-many-instance-attributes
    # Fields map to CbAlertWorkflowState fields
    """
    Dataclass that maps to the CbAlertWorkflowState protobuf message
    """
    status: str = field(default='to_do')
    last_update_timestamp: str = field(default=None)
    changed_by: CbAlertOperator = field(default=None, metadata={'dataclass_type': AlertOperator})
    comment: str = field(default=None)
    close_code: str = field(default=None)
    assigned_to: CbAlertOperator = field(default=None, metadata={'dataclass_type': AlertOperator})
    internal_note: CbAlertSuppressionNote = field(default=None, metadata={'dataclass_type': AlertSuppressionNote})
    external_note: CbAlertSuppressionNote = field(default=None, metadata={'dataclass_type': AlertSuppressionNote})
    _message_type: str = field(init=False, repr=False, default='CbAlertWorkflowState')
