from typing import List

from dataclasses import dataclass, field

from proto_proto_pscr.cb_psc_event_pb2 import (
    CbLegacyV6ThreatIndicators,
    CbLegacyV6AlertThreatCause,
    CbLegacyV6AlertDetails,
)

from sensor_comms.protobuf_requests.event_messages import MessageDataClass
from sensor_comms.protobuf_requests.event_messages.threats.legacy_v6_threat_indicators import LegacyV6ThreatIndicators
from sensor_comms.protobuf_requests.event_messages.threats.legacy_v6_alert_threat_cause import LegacyV6AlertThreatCause


@dataclass
class LegacyV6AlertDetails(MessageDataClass):
    # pylint: disable=too-many-instance-attributes
    # Fields map to CbLegacyV6AlertDetails fields
    """
    Dataclass that maps to the CbLegacyV6AlertDetails protobuf message
    """
    created_by_event_id: str = field(default=None)
    first_event_timestamp: str = field(default=None)
    last_event_timestamp: str = field(default=None)
    threat_indicators: List[CbLegacyV6ThreatIndicators] = field(
        default_factory=list, metadata={'dataclass_type': LegacyV6ThreatIndicators}
    )
    threat_cause: CbLegacyV6AlertThreatCause = field(
        default=None, metadata={'dataclass_type': LegacyV6AlertThreatCause}
    )
    threat_activity_dlp: int = field(
        default=CbLegacyV6AlertDetails.ThreatActivityState.Value('THREAT_ACTIVITY_STATE_UNKNOWN')
    )
    threat_activity_phish: int = field(
        default=CbLegacyV6AlertDetails.ThreatActivityState.Value('THREAT_ACTIVITY_STATE_UNKNOWN')
    )
    threat_activity_c2: int = field(
        default=CbLegacyV6AlertDetails.ThreatActivityState.Value('THREAT_ACTIVITY_STATE_UNKNOWN')
    )
    blocked_threat_category: str = field(default=None)
    not_blocked_threat_category: str = field(default=None)
    kill_chain_status: List[str] = field(default_factory=list)
    primary_process_name: str = field(default=None)
    primary_process_hash: str = field(default=None)
    sensor_action: str = field(default=None)
    _message_type: str = field(init=False, repr=False, default='CbLegacyV6AlertDetails')
