from typing import List

from dataclasses import dataclass, field

from proto_proto_pscr.cb_psc_event_pb2 import (
    CbAlertClassificationPrediction,
    CbMDRAlertClassificationPredictionList,
    MlFeatures,
)

from sensor_comms.protobuf_requests.event_messages import MessageDataClass
from sensor_comms.protobuf_requests.event_messages.alert.alert_classification_prediction import (
    AlertClassificationPrediction,
)
from sensor_comms.protobuf_requests.event_messages.alert.ml_features import MlFeaturesDC


@dataclass
class MDRAlertClassificationPredictionList(MessageDataClass):
    """
    Dataclass that maps to the CbMDRAlertClassificationPredictionList protobuf message
    """

    alert_classification_prediction: List[CbAlertClassificationPrediction] = field(
        default_factory=list, metadata={'dataclass_type': AlertClassificationPrediction}
    )
    final_verdict: int = field(default=CbMDRAlertClassificationPredictionList.Prediction.Value('NO_PREDICTION'))
    cyborg_confidence: int = field(
        default=CbMDRAlertClassificationPredictionList.ModelConfidence.Value('UNKNOWN_CONFIDENCE')
    )
    ml_features: MlFeatures = field(default=None, metadata={'dataclass_type': MlFeaturesDC})
    _message_type: str = field(init=False, repr=False, default='CbMDRAlertClassificationPredictionList')
