from dataclasses import dataclass, field

from typing import List

from proto_proto_pscr.cb_psc_event_pb2 import CbKeyValue

from sensor_comms.protobuf_requests.event_messages import MessageDataClass
from sensor_comms.protobuf_requests.event_messages.key_value import KeyValue


@dataclass
class MicroIDSMetadata(MessageDataClass):
    # pylint: disable=too-many-instance-attributes
    """
    Representation of the CbMicroIDSMetadata protobuf message type
    """
    signature_id: int = field(default=None)
    signature_group_id: int = field(default=None)
    signature_revision: int = field(default=None)
    attack_category: str = field(default=None)
    signature_severity: int = field(default=None)
    signature_confidence: int = field(default=None)
    metadata: List[CbKeyValue] = field(default_factory=list, metadata={'dataclass_type': KeyValue})
    detector_uuid: str = field(default=None)
    is_client_target: bool = field(default=False)
    _message_type: str = field(init=False, repr=False, default='CbMicroIDSMetadata')
