from dataclasses import dataclass, field

from typing import List

from proto_proto_pscr.cb_psc_event_pb2 import CbNtaMetadata, CbKeyValue

from sensor_comms.protobuf_requests.event_messages import MessageDataClass
from sensor_comms.protobuf_requests.event_messages.key_value import KeyValue


@dataclass
class NtaMetadata(MessageDataClass):
    """
    Representation of the CbNtaMetadata protobuf message type
    """

    # pylint: disable=too-many-instance-attributes
    action: int = field(default=CbNtaMetadata.DetectionType.Value('CLASSIFICATION'))
    metadata: List[CbKeyValue] = field(default_factory=list, metadata={'dataclass_type': KeyValue})
    detector_id: str = field(default=None)
    is_client_target: bool = field(default=None)
    is_client_relevant: bool = field(default=None)
    threat_confidence: int = field(default=None)
    primary_alert: bool = field(default=False)
    analytical_metadata: dict = field(default_factory=dict)
    identifier: str = field(default=None)
    _message_type: str = field(init=False, repr=False, default='CbNtaMetadata')
