from dataclasses import dataclass, field

from proto_proto_pscr.cb_psc_event_pb2 import CbWatchlist

from sensor_comms.protobuf_requests.event_messages import MessageDataClass


@dataclass
class Watchlist(MessageDataClass):
    """
    Representation of the CbWatchlist protobuf message type
    """

    id: str = field(default=None)
    name: str = field(default=None)
    lc_tagging_enabled: bool = field(default=True)
    lc_alerting_enabled: bool = field(default=True)
    is_classifiable: bool = field(default=True)
    threat_hunt_name: str = field(default=None)
    threat_hunt_id: str = field(default=None)
    mdr_suppression_rules_enabled: bool = field(default=False)
    mdr_suppress_above_classification_bucket: int = field(
        default=CbWatchlist.MdrSuppressionClassificationBuckets.Value('OFF')
    )
    _message_type: str = field(init=False, repr=False, default='CbWatchlist')
