from dataclasses import dataclass, field

from typing import List

from proto_proto_pscr.cb_psc_event_pb2 import CbWatchlist

from sensor_comms.protobuf_requests.event_messages import MessageDataClass
from sensor_comms.protobuf_requests.event_messages.alert.watchlist import Watchlist


@dataclass
class WatchlistHit(MessageDataClass):
    # pylint: disable=too-many-instance-attributes
    """
    Representation of the CbWatchlistHit protobuf message type
    """
    watchlist: List[CbWatchlist] = field(default_factory=list, metadata={'dataclass_type': Watchlist})
    ioc_condition: str = field(default=None)
    ioc_hit: str = field(default=None)
    hit_document_guid: List[str] = field(default_factory=list)
    ioc_id: str = field(default=None)
    report_id: str = field(default=None)
    report_name: str = field(default=None)
    report_link: str = field(default=None)
    report_timestamp: str = field(default=None)
    report_description: str = field(default=None)
    report_tags: List[str] = field(default_factory=list)
    _message_type: str = field(init=False, repr=False, default='CbWatchlistHit')
