from typing import List
from dataclasses import dataclass, field

from proto_proto_pscr.cb_psc_event_pb2 import CbRulePolicyGuid, CbKeyValue

from sensor_comms.protobuf_requests.event_messages import MessageDataClass
from sensor_comms.protobuf_requests.event_messages.key_value import KeyValue


@dataclass
class RulePolicyGuid(MessageDataClass):
    # pylint: disable=too-many-instance-attributes
    # Fields map to CbRulePolicyGuid fields
    """
    Dataclass that maps to the CbRulePolicyRuleGuid protobuf message
    """
    rule_guid: str = field(default='219833E7-914E-4E0E-886C-63E7DE7853EC')
    policy_guid: str = field(default='19EF3154-298C-4257-B2E0-CB548FDD8909')
    rule_flags: int = field(default=CbRulePolicyGuid.CbRuleFlags.Value('FLAG_TERMINAL'))
    policy_tags: str = field(default='PSCR')
    policy_revision: int = field(default=10)
    rule_revision: int = field(default=None)
    rule_tags: str = field(default=None)
    dispatch_tags: List[str] = field(default_factory=list)
    event_description: str = field(default=None)
    rule_attribution_string: str = field(default=None)
    policy_description: str = field(default=None)
    rule_description: str = field(default=None)
    policy_metadata: List[CbKeyValue] = field(default_factory=list, metadata={'dataclass_type': KeyValue})
    rule_metadata: List[CbKeyValue] = field(default_factory=list, metadata={'dataclass_type': KeyValue})
    _message_type: str = field(init=False, repr=False, default='CbRulePolicyGuid')
