from dataclasses import dataclass, field

from proto_proto_pscr.cb_psc_event_pb2 import CbDigitalSignature

from sensor_comms.protobuf_requests.event_messages import MessageDataClass


@dataclass
class DigitalSignature(MessageDataClass):
    """
    Dataclass that maps to the CbDigitalSignature protobuf message
    """

    publisher: str = field(default=None)
    issuer: str = field(default=None)
    state: int = field(default=CbDigitalSignature.SignatureState.Value('FILE_SIGNATURE_STATE_TRUSTED'))
    sign_timestamp: str = field(default=None)
    signature_error: int = field(default=None)
    _message_type: str = field(init=False, repr=False, default='CbDigitalSignature')
