from typing import List
from dataclasses import dataclass, field

from proto_proto_pscr.cb_psc_event_pb2 import CbFileMetaData

from sensor_comms.protobuf_requests.event_messages import MessageDataClass
from sensor_comms.protobuf_requests.event_messages.files.file_metadata import FileMetaData


@dataclass
class MachOFileMetaData(MessageDataClass):
    # pylint: disable=too-many-instance-attributes
    """
    Dataclass that maps to the CbFileObject protobuf message
    """
    product_name: str = field(default=None)
    company_name: str = field(default=None)
    copyright: str = field(default=None)
    file_description: str = field(default=None)
    original_filename: str = field(default=None)
    product_version: str = field(default=None)
    private_build: str = field(default=None)
    language: str = field(default=None)
    bundle_identifier: str = field(default=None)
    package_type: str = field(default=None)
    category: str = field(default=None)
    entitlements: str = field(default=None)
    additional_data: List[CbFileMetaData] = field(default_factory=list, metadata={'dataclass_type': FileMetaData})
    _message_type: str = field(init=False, repr=False, default='CbMachOFileMetaData')
