from typing import List
from dataclasses import dataclass, field

from proto_proto_pscr.cb_psc_event_pb2 import CbFileMetaData

from sensor_comms.protobuf_requests.event_messages import MessageDataClass
from sensor_comms.protobuf_requests.event_messages.files.file_metadata import FileMetaData


@dataclass
class PEFileMetaData(MessageDataClass):
    # pylint: disable=too-many-instance-attributes
    # Fields map to CbPEFileMetaData fields
    """
    Dataclass that maps to the CbPEFileMetadata protobuf message
    """
    internal_name: str = field(default=None)
    product_name: str = field(default=None)
    company_name: str = field(default=None)
    copyright: str = field(default=None)
    trademark: str = field(default=None)
    file_description: str = field(default=None)
    file_version: str = field(default=None)
    comments: str = field(default=None)
    original_filename: str = field(default=None)
    product_description: str = field(default=None)
    product_version: str = field(default=None)
    private_build: str = field(default=None)
    special_build: str = field(default=None)
    lang_id: int = field(default=None)
    charset_id: int = field(default=None)
    additional_data: List[CbFileMetaData] = field(default_factory=list, metadata={'dataclass_type': FileMetaData})
    _message_type: str = field(init=False, repr=False, default='CbPEFileMetaData')
