from dataclasses import dataclass, field

from proto_proto_pscr.cb_psc_event_pb2 import CbUser, CbWindowsLogonInfo, CbIpAddress, CbPreviousLogonInfo

from sensor_comms.protobuf_requests.event_messages import MessageDataClass
from sensor_comms.protobuf_requests.event_messages.objects.user import User
from sensor_comms.protobuf_requests.event_messages.logon.windows_logon_info import WindowsLogonInfo
from sensor_comms.protobuf_requests.event_messages.network.ip_address import IpAddress
from sensor_comms.protobuf_requests.event_messages.logon.previous_logon_info import PreviousLogonInfo


@dataclass
class Logon(MessageDataClass):
    """
    Fields correspond to fields of CbLogon
    """

    # pylint: disable=too-many-instance-attributes
    unique_logon_id: str = field(default=None)
    logon_time: str = field(default=None)
    user: CbUser = field(default=None, metadata={'dataclass_type': User})
    windows_logon_info: CbWindowsLogonInfo = field(default=None, metadata={'dataclass_type': WindowsLogonInfo})
    service_daemon: bool = field(default=False)
    user_remote_ip_address: CbIpAddress = field(default=None, metadata={'dataclass_type': IpAddress})
    user_remote_port: int = field(default=None)
    user_remote_device_name: str = field(default=None)
    previous_logon_info: CbPreviousLogonInfo = field(default=None, metadata={'dataclass_type': PreviousLogonInfo})
    _message_type: str = field(init=False, repr=False, default='CbLogon')
