from dataclasses import dataclass, field

from typing import List

from proto_proto_pscr.cb_psc_event_pb2 import CbWindowsLogonInfo

from sensor_comms.protobuf_requests.event_messages import MessageDataClass
from sensor_comms.protobuf_requests.event_messages.logon.failure_info import FailureInfoDC


@dataclass
class WindowsLogonInfo(MessageDataClass):
    # pylint: disable=too-many-instance-attributes
    """
    Fields correspond to fields of CbWindowsLogonInfo
    """
    linked_unique_logon_id: str = field(default=None)
    interactive: bool = field(default=True)
    remote_logon: bool = field(default=False)
    cleartext_credentials: bool = field(default=False)
    restricted_admin: bool = field(default=False)
    virtual_account: bool = field(default=False)
    elevated_token: bool = field(default=False)
    impersonation_level: int = field(default=CbWindowsLogonInfo.ImpersonationLevel.Value('IMPERSONATION_NONE'))
    credential_provider: str = field(default=None)
    authentication_package: str = field(default=None)
    authentication_package_version: str = field(default=None)
    authentication_key_length: int = field(default=None)
    authentication_server: str = field(default=None)
    privileges: List[str] = field(default_factory=list)
    password_last_set: str = field(default=None)
    logon_type: int = field(default=None)
    failure_info: CbWindowsLogonInfo.FailureInfo = field(default=None, metadata={'dataclass_type': FailureInfoDC})
    _message_type: str = field(init=False, repr=False, default='CbWindowsLogonInfo')
