from dataclasses import dataclass, field

from typing import List

from proto_proto_pscr.cb_psc_event_pb2 import CbIpAddress, CbUnicastAddress

from sensor_comms.protobuf_requests.event_messages import MessageDataClass
from sensor_comms.protobuf_requests.event_messages.network.ip_address import IpAddress
from sensor_comms.protobuf_requests.event_messages.network.unicast_address import UnicastAddress


@dataclass
class AdapterInfo(MessageDataClass):
    """
    Dataclass that maps to the CbAdapterInfo protobuf message
    """

    default_gateway: CbIpAddress = field(default=None, metadata={'dataclass_type': IpAddress})
    dns_servers: List[CbIpAddress] = field(default_factory=list, metadata={'dataclass_type': IpAddress})
    unicast_addresses: List[CbUnicastAddress] = field(default_factory=list, metadata={'dataclass_type': UnicastAddress})
    dhcp_server: CbIpAddress = field(default=None, metadata={'dataclass_type': IpAddress})
    description: str = field(default=None)
    friendly_name: str = field(default=None)
    _message_type: str = field(init=False, repr=False, default='CbAdapterInfo')
