from dataclasses import dataclass, field

from typing import List

from proto_proto_pscr.cb_psc_event_pb2 import CbKeyValue

from sensor_comms.protobuf_requests.event_messages import MessageDataClass
from sensor_comms.protobuf_requests.event_messages.key_value import KeyValue


@dataclass
class HttpTransaction(MessageDataClass):
    # pylint: disable=too-many-instance-attributes
    # Fields map to CbHttpTransaction fields
    """
    Dataclass that maps to the CbHttpTransaction protobuf message
    """
    hostname: str = field(default=None)
    url: str = field(default=None)
    user_agent: str = field(default=None)
    content_type: str = field(default=None)
    referer: str = field(default=None)
    method: str = field(default=None)
    status_code: int = field(default=None)
    response_content_length: int = field(default=None)
    request_headers: List[CbKeyValue] = field(default_factory=list, metadata={'dataclass_type': KeyValue})
    response_headers: List[CbKeyValue] = field(default_factory=list, metadata={'dataclass_type': KeyValue})
    _message_type: str = field(init=False, repr=False, default='CbHttpTransaction')
