from dataclasses import dataclass, field

from proto_proto_pscr.cb_psc_event_pb2 import CbIpAddress, CbGeoLocation, ThreatScore, CbIpv6Address

from sensor_comms.protobuf_requests.event_messages import MessageDataClass
from sensor_comms.protobuf_requests.event_messages.network.ipv6_address import Ipv6Address
from sensor_comms.protobuf_requests.event_messages.network.geo_location import GeoLocation
from sensor_comms.protobuf_requests.event_messages.threats.threat_score import ThreatScoreDC


@dataclass
class IpAddress(MessageDataClass):
    """
    Dataclass that maps to the CbIpAddress protobuf message
    """

    ip_proto_version: int = field(default=CbIpAddress.IpProtocolVersion.Value('IPV4'))
    ipv4_address: int = field(default=None)
    ipv6_address: CbIpv6Address = field(default=None, metadata={'dataclass_type': Ipv6Address})
    geo_location: CbGeoLocation = field(default=None, metadata={'dataclass_type': GeoLocation})
    ip_address: str = field(default=None)
    threat_score: ThreatScore = field(default=None, metadata={'dataclass_type': ThreatScoreDC})
    _message_type: str = field(init=False, repr=False, default='CbIpAddress')
