from dataclasses import dataclass, field

from proto_proto_pscr.cb_psc_event_pb2 import KubernetesNodeInfo, KubernetesInstanceInfo

from sensor_comms.protobuf_requests.event_messages import MessageDataClass
from sensor_comms.protobuf_requests.event_messages.network.kubernetes.kubernetes_node_info import KubernetesNodeInfoDC
from sensor_comms.protobuf_requests.event_messages.network.kubernetes.kubernetes_instance_info import (
    KubernetesInstanceInfoDC,
)


@dataclass
class KubernetesNetInfoDC(MessageDataClass):
    """
    Dataclass that maps to the KubernetesNetInfo protobuf message
    """

    node_info: KubernetesNodeInfo = field(default=None, metadata={'dataclass_type': KubernetesNodeInfoDC})
    local_instance_info: KubernetesInstanceInfo = field(
        default=None, metadata={'dataclass_type': KubernetesInstanceInfoDC}
    )
    remote_instance_info: KubernetesInstanceInfo = field(
        default=None, metadata={'dataclass_type': KubernetesInstanceInfoDC}
    )
    _message_type: str = field(init=False, repr=False, default='KubernetesNetInfo')
