from dataclasses import dataclass, field

from sensor_comms.protobuf_requests.event_messages import MessageDataClass


@dataclass
class NetFlowInfo(MessageDataClass):
    # pylint: disable=too-many-instance-attributes
    # Fields map to CbNetFlowInfo fields
    """
    Dataclass that maps to the CbNetFlowInfo protobuf message
    """
    bytes_to_client: int = field(default=None)
    bytes_to_server: int = field(default=None)
    packets_to_client: int = field(default=None)
    packets_to_server: int = field(default=None)
    flow_state: str = field(default=None)
    first_packet_timestamp: str = field(default=None)
    last_packet_timestamp: str = field(default=None)
    app_layer_protocol: str = field(default=None)
    flow_id: int = field(default=None)
    ids_instance_id: int = field(default=None)
    tx_id: int = field(default=None)
    _message_type: str = field(init=False, repr=False, default='CbNetFlowInfo')
