from dataclasses import dataclass, field

from typing import List

from sensor_comms.protobuf_requests.event_messages import MessageDataClass


@dataclass
class SmbEvent(MessageDataClass):
    """
    Dataclass that maps to the CbSmbEvent protobuf message
    """

    smb_packet_data: bytes = field(default=None)
    smb_protocol_version: int = field(default=None)
    smb_command: int = field(default=None)
    smb_yara_tags: List[str] = field(default_factory=list)
    smb_connection_type: int = field(default=None)
    _message_type: str = field(init=False, repr=False, default='CbSmbEvent')
