from dataclasses import dataclass, field

from proto_proto_pscr.cb_psc_event_pb2 import CbX509CertificateInfo
from proto_proto_pscr.cb_psc_thirdparty_enums_pb2 import CbTlsCipherSuite

from sensor_comms.protobuf_requests.event_messages import MessageDataClass
from sensor_comms.protobuf_requests.event_messages.network.certificate_info import X509CertificateInfo


@dataclass
class TlsHandshake(MessageDataClass):
    # pylint: disable=too-many-instance-attributes
    # Fields map to CbTlsHandshake fields
    """
    Dataclass that maps to the CbTlsHandshake protobuf message
    """
    server_ssl_certificate: CbX509CertificateInfo = field(
        default_factory=X509CertificateInfo().create_message_object, metadata={'dataclass_type': X509CertificateInfo}
    )
    server_name_indication: str = field(default=None)
    ja3_fingerprint: str = field(default=None)
    ja3_fingerprint_fields: str = field(default=None)
    ja3s_fingerprint: str = field(default=None)
    ja3s_fingerprint_fields: str = field(default=None)
    tls_version: str = field(default=None)
    cipher_suite: str = field(default=None)
    cipher_suite_type: int = field(default=CbTlsCipherSuite.Value('TLS_NULL_WITH_NULL_NULL'))
    _message_type: str = field(init=False, repr=False, default='CbTlsHandshake')
