from dataclasses import dataclass, field

from typing import List

from proto_proto_pscr.cb_psc_event_pb2 import CbZoneIdentifierData

from sensor_comms.protobuf_requests.event_messages import MessageDataClass
from sensor_comms.protobuf_requests.event_messages.objects.zone_identifier_data import ZoneIdentifierData


@dataclass
class AlternateDataStreamData(MessageDataClass):
    """
    Dataclass that maps to the CbAlternateDataStreamData protobuf message
    """

    stream_count: int = field(default=None)
    stream_names: List[str] = field(default_factory=list)
    zone_identifier: CbZoneIdentifierData = field(default=None, metadata={'dataclass_type': ZoneIdentifierData})
    _message_type: str = field(init=False, repr=False, default='CbAlternateDataStreamData')
