from dataclasses import dataclass, field

from sensor_comms.protobuf_requests.event_messages import MessageDataClass


@dataclass
class AmsiContentScanObject(MessageDataClass):
    # pylint: disable=too-many-instance-attributes
    """
    Fields correspond to fields of CbAmsiContentScanObject
    """
    sha256_hash: str = field(default=None)
    deobfuscated_command: str = field(default=None)
    scan_request_id: int = field(default=None)
    scan_request_app_name: str = field(default=None)
    scan_request_content_name: str = field(default=None)
    scan_request_content_size: int = field(default=None)
    scan_request_content_base64_encoded: str = field(default=None)
    scan_session_id: int = field(default=None)
    scan_session_id_64: int = field(default=None)
    scan_session_id_associated_content_source_path: str = field(default=None)
    scan_session_id_associated_content_source_sha256: str = field(default=None)
    _message_type: str = field(init=False, repr=False, default='CbAmsiContentScanObject')
