from typing import List
from dataclasses import dataclass, field

from sensor_comms.protobuf_requests.event_messages import MessageDataClass


@dataclass
class ContainerImageInfo(MessageDataClass):
    # pylint: disable=too-many-instance-attributes
    """
    Dataclass that maps to the CbMountInfo protobuf message
    """
    name: str = field(default=None)
    sha256_hash: str = field(default=None)
    tags: List[str] = field(default_factory=list)
    size: int = field(default=None)
    _message_type: str = field(init=False, repr=False, default='CbContainerImageInfo')
