from dataclasses import dataclass, field
from typing import List

from proto_proto_pscr.cb_psc_event_pb2 import (
    CbContainerUniqueId,
    CbContainerEngine,
    CbFileObject,
    CbIpAddress,
    CbProcessUniqueId,
    CbKeyValue,
    CbMountInfo,
    CbContainerImageInfo,
)

from sensor_comms.protobuf_requests.event_messages import MessageDataClass
from sensor_comms.protobuf_requests.event_messages.objects.container_object.container_unique_id import ContainerUniqueId
from sensor_comms.protobuf_requests.event_messages.objects.container_object.container_engine import ContainerEngine
from sensor_comms.protobuf_requests.event_messages.objects.container_object.mount_info import MountInfo
from sensor_comms.protobuf_requests.event_messages.objects.container_object.container_image_info import (
    ContainerImageInfo,
)
from sensor_comms.protobuf_requests.event_messages.key_value import KeyValue
from sensor_comms.protobuf_requests.event_messages.objects.process_unique_id import ProcessUniqueId
from sensor_comms.protobuf_requests.event_messages.network.ip_address import IpAddress
from sensor_comms.protobuf_requests.event_messages.objects.file_object import FileObject


@dataclass
class ContainerObject(MessageDataClass):
    # pylint: disable=too-many-instance-attributes
    """
    Dataclass that maps to the CbContainerObject protobuf message
    """
    unique_id: CbContainerUniqueId = field(default=None, metadata={'dataclass_type': ContainerUniqueId})
    container_engine: CbContainerEngine = field(default=None, metadata={'dataclass_type': ContainerEngine})
    name: str = field(default=None)
    host_name: str = field(default=None)
    base_image: CbFileObject = field(default=None, metadata={'dataclass_type': FileObject})
    root_path: str = field(default=None)
    ip_address_list: List[CbIpAddress] = field(default_factory=list, metadata={'dataclass_type': IpAddress})
    start_pid: CbProcessUniqueId = field(default=None, metadata={'dataclass_type': ProcessUniqueId})
    tags: List[str] = field(default_factory=list)
    privileged: bool = field(default=False)
    environment_info: List[CbKeyValue] = field(default_factory=list, metadata={'dataclass_type': KeyValue})
    container_annotation: List[CbKeyValue] = field(default_factory=list, metadata={'dataclass_type': KeyValue})
    container_mount_list: List[CbMountInfo] = field(default_factory=list, metadata={'dataclass_type': MountInfo})
    entry_point: str = field(default=None)
    image: CbContainerImageInfo = field(default=None, metadata={'dataclass_type': ContainerImageInfo})
    _message_type: str = field(init=False, repr=False, default='CbContainerObject')
