from dataclasses import dataclass, field

from typing import List

from proto_proto_pscr.cb_psc_event_pb2 import CbCounter, CbPeakCounter

from sensor_comms.protobuf_requests.event_messages import MessageDataClass
from sensor_comms.protobuf_requests.event_messages.objects.counter import Counter
from sensor_comms.protobuf_requests.event_messages.objects.peak_counter import PeakCounter


@dataclass
class CounterData(MessageDataClass):
    """
    Fields correspond to fields of CbCounterData
    """

    counters: List[CbCounter] = field(default_factory=list, metadata={'dataclass_type': Counter})
    peak_counters: List[CbPeakCounter] = field(default_factory=list, metadata={'dataclass_type': PeakCounter})
    millisecond_counters: List[CbPeakCounter] = field(default_factory=list, metadata={'dataclass_type': PeakCounter})
    microsecond_counters: List[CbPeakCounter] = field(default_factory=list, metadata={'dataclass_type': PeakCounter})
    _message_type: str = field(init=False, repr=False, default='CbCounterData')
