from dataclasses import dataclass, field

from proto_proto_pscr.cb_psc_event_pb2 import CbDeviceObject

from sensor_comms.protobuf_requests.event_messages import MessageDataClass


@dataclass
class DeviceObject(MessageDataClass):
    # pylint: disable=too-many-instance-attributes
    """
    Dataclass that maps to the CbDeviceObject protobuf message
    """
    device_type: int = field(default=CbDeviceObject.CbExternalDeviceType.Value('EXTERNAL_DEVICE_TYPE_DISK'))
    interface_type: int = field(default=CbDeviceObject.CbDeviceInterfaceType.Value('DEVICE_INTERFACE_TYPE_USB'))
    device_make: str = field(default=None)
    device_model: str = field(default=None)
    device_friendly_name: str = field(default=None)
    device_serial_number: str = field(default=None)
    device_id: int = field(default=None)
    vendor_id: int = field(default=None)
    _message_type: str = field(init=False, repr=False, default='CbDeviceObject')
