from dataclasses import dataclass, field

from proto_proto_pscr.cb_psc_event_pb2 import CbContainerUniqueId

from sensor_comms.protobuf_requests.utilities.utilities import create_default_pid
from sensor_comms.protobuf_requests.event_messages import MessageDataClass
from sensor_comms.protobuf_requests.event_messages.objects.container_object.container_unique_id import ContainerUniqueId


@dataclass
class ProcessUniqueId(MessageDataClass):
    """
    Dataclass that maps to the CbProcessUniqueId protobuf message
    """

    pid: int = field(default_factory=create_default_pid)
    create_time: str = field(default=None)
    pid_namespace_id: int = field(default=None)
    container_id: CbContainerUniqueId = field(default=None, metadata={'dataclass_type': ContainerUniqueId})
    _message_type: str = field(init=False, repr=False, default='CbProcessUniqueId')
