from dataclasses import dataclass, field

from proto_proto_pscr.cb_psc_event_pb2 import (
    CbSensorAuditObject,
    CbSensorAuditRepcliObject,
    CbSensorAuditBypassObject,
    CbSensorAuditPolicyObject,
    CbSensorAuditVersionData,
    CbSensorAuditSessionObject,
    CbSensorAuditPowerObject,
    CbSensorAuditClockObject,
    CbSensorAuditTask,
)

from sensor_comms.protobuf_requests.event_messages import MessageDataClass
from sensor_comms.protobuf_requests.event_messages.objects.sensor.sensor_audit_repcli_object import (
    SensorAuditRepcliObject,
)
from sensor_comms.protobuf_requests.event_messages.objects.sensor.sensor_audit_bypass_object import (
    SensorAuditBypassObject,
)
from sensor_comms.protobuf_requests.event_messages.objects.sensor.sensor_audit_policy_object import (
    SensorAuditPolicyObject,
)
from sensor_comms.protobuf_requests.event_messages.objects.sensor.sensor_audit_version_data import (
    SensorAuditVersionData,
)
from sensor_comms.protobuf_requests.event_messages.objects.sensor.sensor_audit_session_object import (
    SensorAuditSessionObject,
)
from sensor_comms.protobuf_requests.event_messages.objects.sensor.sensor_audit_power_object import (
    SensorAuditPowerObject,
)
from sensor_comms.protobuf_requests.event_messages.objects.sensor.sensor_audit_clock_object import (
    SensorAuditClockObject,
)
from sensor_comms.protobuf_requests.event_messages.objects.sensor.sensor_audit_task import SensorAuditTask


@dataclass
class SensorAuditObject(MessageDataClass):
    # pylint: disable=too-many-instance-attributes
    """
    Fields correspond to fields of CbSensorAuditObject
    """
    audit_type: int = field(default=CbSensorAuditObject.AuditType.Value('AUDIT_TASK'))
    audit_data: str = field(default=None)
    audit_repcli: CbSensorAuditRepcliObject = field(default=None, metadata={'dataclass_type': SensorAuditRepcliObject})
    audit_bypass: CbSensorAuditBypassObject = field(default=None, metadata={'dataclass_type': SensorAuditBypassObject})
    audit_policy: CbSensorAuditPolicyObject = field(default=None, metadata={'dataclass_type': SensorAuditPolicyObject})
    audit_version: CbSensorAuditVersionData = field(default=None, metadata={'dataclass_type': SensorAuditVersionData})
    audit_session: CbSensorAuditSessionObject = field(
        default=None, metadata={'dataclass_type': SensorAuditSessionObject}
    )
    audit_power: CbSensorAuditPowerObject = field(default=None, metadata={'dataclass_type': SensorAuditPowerObject})
    audit_clock: CbSensorAuditClockObject = field(default=None, metadata={'dataclass_type': SensorAuditClockObject})
    audit_task: CbSensorAuditTask = field(default=None, metadata={'dataclass_type': SensorAuditTask})
    _message_type: str = field(init=False, repr=False, default='CbSensorAuditObject')
