from dataclasses import dataclass, field

from typing import List

from proto_proto_pscr.cb_psc_event_pb2 import CbSensorAuditTask, CbKeyValue

from sensor_comms.protobuf_requests.event_messages import MessageDataClass
from sensor_comms.protobuf_requests.event_messages.key_value import KeyValue


@dataclass
class SensorAuditTask(MessageDataClass):
    # pylint: disable=too-many-instance-attributes
    """
    Fields correspond to fields of CbSensorAuditTask
    """
    initiator: str = field(default=None)
    task_type: int = field(default=CbSensorAuditTask.TaskType.Value('TASK_TYPE_NONE'))
    sub_task: str = field(default=None)
    task_props: List[CbKeyValue] = field(default_factory=list, metadata={'dataclass_type': KeyValue})
    task_status: int = field(default=CbSensorAuditTask.TaskStatus.Value('TASK_STATUS_UNKNOWN'))
    duration: str = field(default=None)
    task_guid: str = field(default=None)
    _message_type: str = field(init=False, repr=False, default='CbSensorAuditTask')
