from dataclasses import dataclass, field

from typing import List

from proto_proto_pscr.cb_psc_event_pb2 import CbComponentVersion, CbSensorAuditPolicyObject

from sensor_comms.protobuf_requests.event_messages import MessageDataClass
from sensor_comms.protobuf_requests.event_messages.objects.sensor.component_version import ComponentVersion
from sensor_comms.protobuf_requests.event_messages.objects.sensor.sensor_audit_policy_object import (
    SensorAuditPolicyObject,
)


@dataclass
class SensorAuditVersionData(MessageDataClass):
    """
    Fields correspond to fields of CbSensorAuditVersionData
    """

    manifest_signature_hash: str = field(default=None)
    component_versions: List[CbComponentVersion] = field(
        default_factory=list, metadata={'dataclass_type': ComponentVersion}
    )
    policy_versions: List[CbSensorAuditPolicyObject] = field(
        default_factory=list, metadata={'dataclass_type': SensorAuditPolicyObject}
    )
    _message_type: str = field(init=False, repr=False, default='CbSensorAuditVersionData')
