from dataclasses import dataclass, field
from typing import List

from proto_proto_pscr.cb_psc_event_pb2 import CbStateMachineState, KubernetesContext

from sensor_comms.protobuf_requests.event_messages import MessageDataClass
from sensor_comms.protobuf_requests.event_messages.objects.state_machine_state import StateMachineState
from sensor_comms.protobuf_requests.event_messages.network.kubernetes.kubernetes_context import KubernetesContextDC


@dataclass
class SystemObject(MessageDataClass):
    """
    Dataclass that maps to the CbSystemObject protobuf message
    """

    tags: List[str] = field(default_factory=list)
    state: List[CbStateMachineState] = field(default_factory=list, metadata={'dataclass_type': StateMachineState})
    kubernetes_context: KubernetesContext = field(default=None, metadata={'dataclass_type': KubernetesContextDC})
    _message_type: str = field(init=False, repr=False, default='CbSystemObject')
