from typing import List
from dataclasses import dataclass, field

from sensor_comms.protobuf_requests.event_messages import MessageDataClass


@dataclass
class User(MessageDataClass):
    """
    Dataclass that maps to the CbUser protobuf message
    """

    user_id: str = field(default=None)
    user_name: str = field(default=None)
    domain_name: str = field(default=None)
    upn: str = field(default=None)
    user_groups: List[str] = field(default_factory=list)
    _message_type: str = field(init=False, repr=False, default='CbUser')
