from dataclasses import dataclass, field

from proto_proto_pscr.cb_psc_event_pb2 import CbDeviceObject

from sensor_comms.protobuf_requests.event_messages import MessageDataClass
from sensor_comms.protobuf_requests.event_messages.objects.device_object import DeviceObject


@dataclass
class VolumeObject(MessageDataClass):
    """
    Dataclass that maps to the CbVolumeObject protobuf message
    """

    filesystem_type: str = field(default=None)
    volume_serial_number: int = field(default=None)
    volume_id: str = field(default=None)
    device_name: str = field(default=None)
    device_object: CbDeviceObject = field(default=None, metadata={'dataclass_type': DeviceObject})
    _message_type: str = field(init=False, repr=False, default='CbVolumeObject')
