from dataclasses import dataclass, field

from typing import List

from sensor_comms.protobuf_requests.event_messages import MessageDataClass


@dataclass
class Win32ProcessData(MessageDataClass):
    """
    Dataclass that maps to the CbWin32PredictionData protobuf message
    """

    service_name: List[str] = field(default_factory=list)
    thread_suspended: bool = field(default=False)
    elevated: bool = field(default=False)
    integrity_level: int = field(default=None)
    privileges: List[str] = field(default_factory=list)
    _message_type: str = field(init=False, repr=False, default='CbWin32ProcessData')
