from dataclasses import dataclass, field

from proto_proto_pscr.cb_psc_event_pb2 import CbDeviceOp, CbDeviceObject

from sensor_comms.protobuf_requests.event_messages import MessageDataClass
from sensor_comms.protobuf_requests.event_messages.objects.device_object import DeviceObject


@dataclass
class DeviceOperation(MessageDataClass):
    """
    Fields correspond to fields of CbDeviceOp
    """

    action: int = field(default=CbDeviceOp.CbDeviceAction.Value('ACTION_DEVICE_ADD'))
    target_device: CbDeviceObject = field(default=None, metadata={'dataclass_type': DeviceObject})
    protected_range_type: int = field(default=CbDeviceOp.CbProtectedRangeType.Value('PROTECTED_RANGE_TYPE_UNKNOWN'))
    _message_type: str = field(init=False, repr=False, default='CbDeviceOp')
