from dataclasses import dataclass, field
from typing import List

from proto_proto_pscr.cb_psc_event_pb2 import CbDnsRecord
from proto_proto_pscr.cb_psc_thirdparty_enums_pb2 import CbDnsRecordType, CbDnsRecordClass

from sensor_comms.protobuf_requests.event_messages.operations.dns.dns_record import DnsRecord
from sensor_comms.protobuf_requests.event_messages import MessageDataClass


@dataclass
class DnsEvent(MessageDataClass):
    # pylint: disable=too-many-instance-attributes
    """
    Dataclass that maps to the CbDnsEvent protobuf message
    """
    is_answer: bool = field(default=None)
    dns_message_id: int = field(default=None)
    qr_flag: bool = field(default=None)
    aa_flag: bool = field(default=None)
    tc_flag: bool = field(default=None)
    rd_flag: bool = field(default=None)
    ra_flag: bool = field(default=None)
    z_flag: bool = field(default=None)
    operation_code: int = field(default=None)
    response_code: int = field(default=None)
    resource_record_name: str = field(default=None)
    resource_record_type: int = field(default=CbDnsRecordType.Value('DNS_RECORD_TYPE_UNKNOWN'))
    resource_record_class: int = field(default=CbDnsRecordClass.Value('DNS_RECORD_CLASS_UNKNOWN'))
    dns_answer: List[CbDnsRecord] = field(default_factory=list, metadata={'dataclass_type': DnsRecord})
    dns_answer_identifier_hash: int = field(default=None)
    _message_type: str = field(init=False, repr=False, default='CbDnsEvent')
