from dataclasses import dataclass, field

from proto_proto_pscr.cb_psc_event_pb2 import CbDnsSoa, CbDnsSrv, CbDnsSshfp
from proto_proto_pscr.cb_psc_thirdparty_enums_pb2 import CbDnsRecordType, CbDnsRecordClass

from sensor_comms.protobuf_requests.event_messages import MessageDataClass
from sensor_comms.protobuf_requests.event_messages.operations.dns.dns_soa import DnsSoa
from sensor_comms.protobuf_requests.event_messages.operations.dns.dns_srv import DnsSrv
from sensor_comms.protobuf_requests.event_messages.operations.dns.dns_sshfp import DnsSshfp


@dataclass
class DnsRecord(MessageDataClass):
    # pylint: disable=too-many-instance-attributes
    """
    Dataclass that maps to the CbDnsEvent protobuf message
    """
    name: str = field(default=None)
    type: int = field(default=CbDnsRecordType.Value('DNS_RECORD_TYPE_UNKNOWN'))
    record_class: int = field(default=CbDnsRecordClass.Value('DNS_RECORD_CLASS_UNKNOWN'))
    ttl: int = field(default=None)
    data: str = field(default=None)
    soa: CbDnsSoa = field(default=None, metadata={'dataclass_type': DnsSoa})
    srv: CbDnsSrv = field(default=None, metadata={'dataclass_type': DnsSrv})
    sshfp: CbDnsSshfp = field(default=None, metadata={'dataclass_type': DnsSshfp})
    string_data_size: int = field(default=None)
    _message_type: str = field(init=False, repr=False, default='CbDnsRecord')
