from dataclasses import dataclass, field

from proto_proto_pscr.cb_psc_event_pb2 import CbFileObject, CbFileOp, RemoteFileOp

from sensor_comms.protobuf_requests.event_messages import MessageDataClass

from sensor_comms.protobuf_requests.event_messages.objects.file_object import FileObject
from sensor_comms.protobuf_requests.event_messages.operations.remote_file_op import RemoteFileOpDC


@dataclass
class FileOperation(MessageDataClass):
    # pylint: disable=too-many-instance-attributes
    """
    Fields correspond to fields of CbFileOp
    """
    action: int = field(default=CbFileOp.CbFileAction.Value('ACTION_FILE_CREATE'))
    target: CbFileObject = field(default=None, metadata={'dataclass_type': FileObject})
    new_path: str = field(default=None)
    write_count: int = field(default=None)
    first_write_timestamp: str = field(default=None)
    first_write_offset: int = field(default=None)
    first_write_size: int = field(default=None)
    last_write_timestamp: str = field(default=None)
    last_write_offset: int = field(default=None)
    last_write_size: int = field(default=None)
    remote_info: RemoteFileOp = field(default=None, metadata={'dataclass_type': RemoteFileOpDC})
    _message_type: str = field(init=False, repr=False, default='CbFileOp')
