from dataclasses import dataclass, field

from proto_proto_pscr.cb_psc_event_pb2 import (
    CbLoadModuleOp,
    CbFileObject,
    CbAmsiContentScanObject,
    CbFilelessDotNetModule,
)

from sensor_comms.protobuf_requests.event_messages import MessageDataClass

from sensor_comms.protobuf_requests.event_messages.objects.file_object import FileObject
from sensor_comms.protobuf_requests.event_messages.objects.amsi_content_scan_object import AmsiContentScanObject
from sensor_comms.protobuf_requests.event_messages.network.fileless_dot_net_module import FilelessDotNetModule


@dataclass
class LoadModuleOperation(MessageDataClass):
    """
    Fields correspond to fields of CbLoadModuleOp
    """

    action: int = field(default=CbLoadModuleOp.CbLoadModuleAction.Value('ACTION_LOAD_MODULE'))
    target: CbFileObject = field(default=None, metadata={'dataclass_type': FileObject})
    amsi_content_scan_target: CbAmsiContentScanObject = field(
        default=None, metadata={'dataclass_type': AmsiContentScanObject}
    )
    fileless_dot_net_module_target: CbFilelessDotNetModule = field(
        default=None, metadata={'dataclass_type': FilelessDotNetModule}
    )
    _message_type: str = field(init=False, repr=False, default='CbLoadModuleOp')
