from dataclasses import dataclass, field

from proto_proto_pscr.cb_psc_event_pb2 import (
    CbNetConnectionObject,
    CbNetFlowInfo,
    CbAdapterInfo,
    CbNetOp,
    CbHttpTransaction,
    CbTlsHandshake,
    CbDnsEvent,
    CbSmbEvent,
)

from sensor_comms.protobuf_requests.event_messages.objects.network_connection_object import NetworkConnectionObject
from sensor_comms.protobuf_requests.event_messages.network.adapter_info import AdapterInfo
from sensor_comms.protobuf_requests.event_messages.network.net_flow_info import NetFlowInfo
from sensor_comms.protobuf_requests.event_messages.network.http_transaction import HttpTransaction
from sensor_comms.protobuf_requests.event_messages.network.tls_handshake import TlsHandshake
from sensor_comms.protobuf_requests.event_messages.network.smb_event import SmbEvent
from sensor_comms.protobuf_requests.event_messages.operations.dns.dns_event import DnsEvent
from sensor_comms.protobuf_requests.event_messages import MessageDataClass


@dataclass
class NetworkOperation(MessageDataClass):
    # pylint: disable=too-many-instance-attributes
    """
    Dataclass that maps to the CbNetworkOperation protobuf message
    """
    action: int = field(default=CbNetOp.CbNetAction.Value('ACTION_HTTP'))
    target: CbNetConnectionObject = field(
        default_factory=NetworkConnectionObject().create_message_object,
        metadata={'dataclass_type': NetworkConnectionObject},
    )
    flow_info: CbNetFlowInfo = field(default=None, metadata={'dataclass_type': NetFlowInfo})
    http_transaction: CbHttpTransaction = field(default=None, metadata={'dataclass_type': HttpTransaction})
    tls_handshake: CbTlsHandshake = field(default=None, metadata={'dataclass_type': TlsHandshake})
    dns_event: CbDnsEvent = field(default=None, metadata={'dataclass_type': DnsEvent})
    adapter_info: CbAdapterInfo = field(default=None, metadata={'dataclass_type': AdapterInfo})
    popularity: int = field(default=None)
    smb_event: CbSmbEvent = field(default=None, metadata={'dataclass_type': SmbEvent})
    _message_type: str = field(init=False, repr=False, default='CbNetOp')
