from dataclasses import dataclass, field

from typing import List

from proto_proto_pscr.cb_psc_event_pb2 import CbProcessOp, CbDynamicEventData, CbKeyValue, CbProcessObject

from sensor_comms.protobuf_requests.event_messages import MessageDataClass
from sensor_comms.protobuf_requests.event_messages.key_value import KeyValue
from sensor_comms.protobuf_requests.event_messages.objects.process_object import ProcessObject
from sensor_comms.protobuf_requests.event_messages.event.dynamic_event_data import DynamicEventData


@dataclass
class ProcessOperation(MessageDataClass):
    """
    ProcessOperation dataclass. Fields correspond to fields of CbProcessOp message
    """

    # pylint: disable=too-many-instance-attributes
    action: int = field(default=CbProcessOp.CbProcessAction.Value('ACTION_CREATE_PROCESS'))
    target: CbProcessObject = field(default=None, metadata={'dataclass_type': ProcessObject})
    target_parent: CbProcessObject = field(default=None, metadata={'dataclass_type': ProcessObject})
    create_type: int = field(default=CbProcessOp.CbProcessCreateType.Value('TYPE_EXEC'))
    create_flags: int = field(default=CbProcessOp.CbProcessCreateFlags.Value('FLAG_NOT_SET'))
    desired_access: int = field(default=None)
    granted_access: int = field(default=None)
    extended_props: List[CbKeyValue] = field(default_factory=list, metadata={'dataclass_type': KeyValue})
    target_exec_parent: CbProcessObject = field(default=None, metadata={'dataclass_type': ProcessObject})
    api_name: str = field(default=None)
    api_call_args: List[CbDynamicEventData] = field(default_factory=list, metadata={'dataclass_type': DynamicEventData})
    _message_type: str = field(init=False, repr=False, default='CbProcessOp')
