from dataclasses import dataclass, field

from proto_proto_pscr.cb_psc_event_pb2 import CbRegistryOp, CbRegistryObject

from sensor_comms.protobuf_requests.event_messages import MessageDataClass

from sensor_comms.protobuf_requests.event_messages.objects.registry_object import RegistryObject


@dataclass
class RegistryOperation(MessageDataClass):
    """
    Fields correspond to fields of CbRegistryOp
    """

    action: int = field(default=CbRegistryOp.CbRegistryAction.Value('ACTION_CREATE_KEY'))
    target: CbRegistryObject = field(default=None, metadata={'dataclass_type': RegistryObject})
    new_key_path: str = field(default=None)
    write_value_data: bytes = field(default=None)
    write_value_data_type: int = field(default=None)
    _message_type: str = field(init=False, repr=False, default='CbRegistryOp')
