from dataclasses import dataclass, field

from proto_proto_pscr.cb_psc_event_pb2 import CbSystemOp, CbSystemTarget, CbEtwOperationObject

from sensor_comms.protobuf_requests.event_messages import MessageDataClass
from sensor_comms.protobuf_requests.event_messages.objects.system_target import SystemTarget
from sensor_comms.protobuf_requests.event_messages.objects.etw_operation_object import EtwOperationTarget


@dataclass
class SystemOperation(MessageDataClass):
    """
    Fields correspond to fields of CbSystemOp
    """

    action: int = field(default=CbSystemOp.CbSystemAction.Value('ACTION_SYSTEM_ETW_GENERIC'))
    target: CbSystemTarget = field(default=None, metadata={'dataclass_type': SystemTarget})
    etw_op: CbEtwOperationObject = field(default=None, metadata={'dataclass_type': EtwOperationTarget})
    _message_type: str = field(init=False, repr=False, default='CbSystemOp')
