from dataclasses import dataclass, field

from proto_proto_pscr.cb_psc_event_pb2 import CbTelemetryOp, CbSensorAlarmObject, CbSensorAuditObject, CbCounterData

from sensor_comms.protobuf_requests.event_messages import MessageDataClass
from sensor_comms.protobuf_requests.event_messages.objects.sensor.sensor_alarm_object import SensorAlarmObject
from sensor_comms.protobuf_requests.event_messages.objects.sensor.sensor_audit_session_object import (
    SensorAuditSessionObject,
)
from sensor_comms.protobuf_requests.event_messages.objects.counter_data import CounterData


@dataclass
class TelemetryOperation(MessageDataClass):
    """
    Fields correspond to fields of CbTelemetryOp
    """

    action: int = field(default=CbTelemetryOp.CbTelemetryAction.Value('ACTION_SENSOR_HEALTH'))
    sensor_health: CbSensorAlarmObject = field(default=None, metadata={'dataclass_type': SensorAlarmObject})
    sensor_audit: CbSensorAuditObject = field(default=None, metadata={'dataclass_type': SensorAuditSessionObject})
    counter_data: CbCounterData = field(default=None, metadata={'dataclass_type': CounterData})
    _message_type: str = field(init=False, repr=False, default='CbTelemetryOp')
